<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    selectedTab: {
      type: Number,
      required: true,
      default: 0,
    },
  },
  data() {
    return {
      baseImgUrl: '/nuxt-images/competition/progress-bars/',
    };
  },
  methods: {
    progressBarAltText(percent: number) {
      switch (percent) {
        case 0:
          return 'Progress bar that shows the current feature capability as little or no capability';
        case 25:
          return 'Progress bar that shows the current feature capability as basic';
        case 50:
          return 'Progress bar that shows the current feature capability as adequate';
        case 75:
          return 'Progress bar that shows the current feature capability as good';
        case 100:
          return 'Progress bar that shows the current feature capability as comprehensive';
        default:
          return null;
      }
    },
  },
});
</script>

<template>
  <div class="wrapper">
    <div class="tabs" role="tablist">
      <div v-for="(tab, tabIndex) in data.tabs" :key="tab.header.text">
        <button
          :id="`${tab.header.text}-control`"
          class="tab"
          role="tab"
          type="button"
          :tabindex="selectedTab === tabIndex ? '-1' : 0"
          :class="{
            selected: selectedTab === tabIndex,
            first: tabIndex == 0,
            last: tabIndex == data.tabs.length - 1,
          }"
          :aria-selected="selectedTab === tabIndex"
          :aria-controls="`${tab.header.text}-panel`"
          @click="$emit('tab-change', tabIndex)"
        >
          <SlpIcon
            class="icon"
            :name="tab.header.icon"
            variant="marketing"
            size="md"
          />
          <SlpTypography variant="body2">{{ tab.header.text }}</SlpTypography>
        </button>
        <div class="overview">
          <div>
            <SlpTypography variant="body2-bold" tag="p"> GitLab </SlpTypography>
            <img
              :src="`${baseImgUrl}${tab.overview.gitlab_progress}.svg`"
              :alt="progressBarAltText(tab.overview.gitlab_progress)"
            />
          </div>
          <div>
            <SlpButton
              variant="tertiary"
              href="/competition/github"
              data-ga-name="gitlab vs github"
              data-ga-location="competition tabs"
            >
              GitHub
              <SlpIcon
                class="learn-more-icon"
                name="chevron-right"
                variant="product"
              />
            </SlpButton>
            <img
              :src="`${baseImgUrl}${tab.overview.github_progress}.svg`"
              :alt="progressBarAltText(tab.overview.github_progress)"
            />
          </div>

          <div v-if="tab.competitors[1]">
            <SlpButton
              v-if="tab.competitors[1].href"
              variant="tertiary"
              :href="tab.competitors[1].href"
              :data-ga-name="`gitlab vs ${tab.competitors[1].text}`"
              data-ga-location="competition tabs"
            >
              {{ tab.competitors[1].text }}
              <SlpIcon
                class="learn-more-icon"
                name="chevron-right"
                variant="product"
              />
            </SlpButton>
            <SlpTypography
              v-else
              class="fallback"
              variant="body2-bold"
              tag="p"
              >{{ tab.competitors[1].text }}</SlpTypography
            >
            <img
              :src="`${baseImgUrl}${tab.overview.bic_progress}.svg`"
              :alt="progressBarAltText(tab.overview.bic_progress)"
            />
          </div>
        </div>
      </div>
    </div>
    <div class="mobile-overview">
      <div>
        <SlpTypography variant="body2-bold" tag="p"> GitLab </SlpTypography>
        <img
          :src="`${baseImgUrl}${data.tabs[selectedTab].overview.gitlab_progress}.svg`"
        />
      </div>
      <div>
        <SlpButton
          variant="tertiary"
          href="/competition/github"
          data-ga-name="gitlab vs github"
          data-ga-location="competition tabs"
        >
          GitHub
          <SlpIcon
            class="learn-more-icon"
            name="chevron-right"
            variant="product"
          />
        </SlpButton>
        <img
          :src="`${baseImgUrl}${data.tabs[selectedTab].overview.github_progress}.svg`"
        />
      </div>

      <div v-if="data.tabs[selectedTab].competitors[1]">
        <SlpButton
          variant="tertiary"
          :href="data.tabs[selectedTab].competitors[1].href"
          :data-ga-name="`gitlab vs ${data.tabs[selectedTab].competitors[1].text}`"
          data-ga-location="competition tabs"
        >
          {{ data.tabs[selectedTab].competitors[1].text }}
          <SlpIcon
            class="learn-more-icon"
            name="chevron-right"
            variant="product"
          />
        </SlpButton>
        <img
          :src="`${baseImgUrl}${data.tabs[selectedTab].overview.bic_progress}.svg`"
        />
      </div>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.wrapper {
  display: flex;
  align-items: center;
  position: relative;
  height: 100%;

  @media (max-width: $breakpoint-md) {
    flex-direction: column;
  }
}

.mobile-overview {
  display: none;
  @media (max-width: $breakpoint-md) {
    display: block;
    background: $color-surface-100;
    width: 100%;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: center;
    padding: $spacing-32 $spacing-16 $spacing-24 $spacing-16;
    .slp-btn {
      padding: 0;
      justify-content: center;
      font-size: 16px;
    }

    & > div {
      flex-grow: 1;
      display: flex;
      flex-direction: column;
      flex-wrap: nowrap;
      align-items: center;
    }

    img {
      margin-top: 4px;
    }
  }
}
.tabs {
  width: 100%;
  display: flex;
  justify-content: space-between;
  background: $color-surface-50;
  border-top-left-radius: 8px;
  border-top-right-radius: 8px;

  @media (max-width: $breakpoint-lg) {
    background: $color-surface-100;
    padding-bottom: $spacing-16;
    overflow-x: scroll;
    -ms-overflow-style: none; /* Internet Explorer 10+ */
    scrollbar-width: none; /* Firefox */

    &::-webkit-scrollbar {
      display: none; /* Safari and Chrome */
    }
  }

  .tab {
    position: relative;
    min-width: 100px;
    max-height: 200px;
    padding: 16px;
    text-align: center;
    display: flex;
    flex-direction: column;
    align-items: center;
    justify-content: flex-start;
    background: $color-surface-50;
    border-bottom: 3px solid transparent;
    border-top: none;
    border-left: none;
    border-right: none;
    width: 100%;
    color: $color-text-300;

    &.first {
      border-top-left-radius: 8px;

      & ~ .overview {
        border-left: none;
      }
    }

    &.last {
      border-top-right-radius: 8px;
    }

    @media (max-width: $breakpoint-md) {
      .icon {
        margin-bottom: $spacing-8;
      }
    }
    .icon {
      margin-bottom: 16px;
      height: 24px;
      width: 24px;
    }

    &:hover span {
      font-weight: $font-weight-bold;
    }
    cursor: pointer;
    &.selected {
      border-bottom: 3px solid $color-accent-500;
      position: relative;

      & + .overview {
        background: $color-surface-100;
      }

      &:after {
        content: '';
        background: url('/nuxt-images/competition/active-arrow.svg');
        background-repeat: no-repeat;
        z-index: 2;
        position: absolute;
        width: 19px;
        height: 11px;
        left: 50%;
        transform: translateX(-50%);
        bottom: -13px;
      }
      span {
        font-weight: $font-weight-bold;
      }
    }
  }

  .overview {
    padding: $spacing-24 $spacing-16 0 $spacing-16;
    background: $color-surface-50;
    text-align: left;
    font-weight: $font-weight-bold;
    min-height: 215px;
    border-top: 1px solid $color-surface-200;
    border-left: 1px solid $color-surface-200;

    @media (max-width: $breakpoint-md) {
      display: none;
    }

    .slp-btn {
      font-size: 16px;
      padding: 11px 0 0 0;
    }

    img {
      width: 90px;
    }
  }
}

.fallback {
  padding-top: 11px;
}
</style>
